<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
  <meta name="viewport" content="maximum-scale=1.6,width=320,user-scalable=false" />
  <meta http-equiv="refresh" content="5">
  <meta http-equiv="content-type" content="text/html; charset=utf-8"/>

  <title>Pulse Ox Status</title>

<?php

try
{
$dbh = new PDO('sqlite:/var/www/pulseox.db');
$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

// query result will look like the following:
// 11/17/12 06:47:24 SPO2=092% BPM=128
$query=$dbh->prepare("SELECT stampdate, stamptime, spo2, bpm from pulseox order by id desc limit 1");
$query->execute();
$result=$query->fetch();

$chart_bpm_data = $result[3];
$chart_spo2_data = substr($result[2], 0, -1); // strip off the last '%' character

$last_update = $result[0] . " @ " . $result[1];

//retrieve a bunch of BPMs and SPO2s for averaging - result will look like:
// 83.8 99.5
$query=$dbh->prepare("SELECT round(avg(substr(bpm,5,3)),1), round(avg(substr(spo2,6,3)),1) from pulseox where bpm != 'BPM=---' and spo2 != 'SPO2=---%' and id > ((select max(id) from pulseox) - 3600)");
$query->execute();
$result=$query->fetch();
$chart_avg_bpm_data = $result[0];
$chart_avg_spo2_data = $result[1];

$dbh = null;

}
catch(PDOException $e)
{
print 'Exception: ' .$e->getMessage();
}

?>

    <script type="text/javascript" src="http://www.google.com/jsapi"></script>
    <script type="text/javascript">
      google.load('visualization', '1', {packages: ['gauge']});
    </script>
    <script type="text/javascript">
      function drawVisualization() {
        // Create and populate the data table.
		var bpm_data = google.visualization.arrayToDataTable([
			['Label', 'Value'],
  			['BPM', <?php echo $chart_bpm_data; ?>]]);

		var spo2_data = google.visualization.arrayToDataTable([
			['Label', 'Value'],
  			['SPO2', <?php echo $chart_spo2_data; ?>]]);

		var avg_bpm_data = google.visualization.arrayToDataTable([
			['Label', 'Value'],
  			['AVG BPM', <?php echo $chart_avg_bpm_data; ?>]]);

		var avg_spo2_data = google.visualization.arrayToDataTable([
			['Label', 'Value'],
  			['AVG SPO2', <?php echo $chart_avg_spo2_data; ?>]]);

        var BPM_Chart_Options = {
          min: 0, max: 200,
          greenFrom: 60, greenTo: 130,
          redFrom: 160, redTo: 200,
          yellowFrom:130, yellowTo: 160,
          minorTicks: 5,
        };
        		    
        var SPO2_Chart_Options = {
          min: 0, max: 100,
          greenFrom: 90, greenTo: 100,
          redFrom: 50, redTo: 80,
          yellowFrom:80, yellowTo: 90,
          minorTicks: 5,
        };
        		    
        // Create and draw the visualization.
        var bpm_chart = new google.visualization.Gauge(document.getElementById('chart1'));
        bpm_chart.draw(bpm_data, BPM_Chart_Options);

        var spo2_chart = new google.visualization.Gauge(document.getElementById('chart2'));
        spo2_chart.draw(spo2_data, SPO2_Chart_Options);

        var avg_bpm_chart = new google.visualization.Gauge(document.getElementById('chart3'));
        avg_bpm_chart.draw(avg_bpm_data, BPM_Chart_Options);

        var avg_spo2_chart = new google.visualization.Gauge(document.getElementById('chart4'));
        avg_spo2_chart.draw(avg_spo2_data, SPO2_Chart_Options);
      }
      

      google.setOnLoadCallback(drawVisualization);
    </script>
  </head>
  <body style="font-family: Arial;border: 0 none;">
  <?php echo "Updated: $last_update"; ?>
  <div id="containerDiv" style="width: 300px;">
    <div id="chart1" style="float:left; width: 150px; height: 150px;"></div>
    <div id="chart2" style="float:left; width: 150px; height: 150px;"></div>
    <div id="chart3" style="float:left; width: 150px; height: 150px;"></div>
    <div id="chart4" style="float:left; width: 150px; height: 150px;"></div>
  </div>
  </body>
</html>
​
